indexing
	description: "[
	  "	The MessageReceiver is an own thread that runs continuously to receive
 		and display messages (in MESSAGE_RECEIVER).";
	  
	  Authors: Keno Albrecht and Angela Nicoara
	]"

	date: "$Date: 2005/04/14 14:42:40 $";
	revision: "$Revision: 1.3 $"

class 
		RECEIVER_THREAD

inherit
		THREAD

create
		make_me

feature

		socket: NETWORK_DATAGRAM_SOCKET
		user_list: LINKED_LIST[USER]
		
		stopFlag: BOOLEAN

		make_me (socket_: NETWORK_DATAGRAM_SOCKET; user_list_: LINKED_LIST[USER]) is
		do
			socket := socket_
			user_list := user_list_
			
			stopFlag := false
		end

		-- Routine executed by new thread
		-- Create a poller, enters the read commands into the poller and execute the poller
		execute is
		local
			ps_read: MEDIUM_POLLER
			readcomm: MESSAGE_RECEIVER
		do
			if (stopFlag = false) then
				-- Create poller for multi-event polling
				create ps_read.make
				create readcomm.make_me (socket, user_list)
				-- Enters the read command into the poller
				ps_read.put_read_command (readcomm)
				
				from until stopFlag loop
					-- Monitors the socket for the corresponding events and 
					-- executes the command associated with the event that will be received
					ps_read.execute (15, 20000)
				end
			end
		rescue
			stop
			retry
		end
		
		stop is
		do
			stopFlag := true
		end		

end -- class RECEIVER_THREAD
